#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\opensave.h>

#define VBXGEN_DATA
#define KNIFE_DATA
#include <knife1.h>
#include <knifevbx.h>
#include "knife.rh"

class TMyWindow : public TWindow {
  public:
	 TMyWindow(TWindow *parent = 0);
	 ~TMyWindow(){imkEnd(); }
	 TVbxPicBuf *VbxPicBuf;
  protected:
	 // Message response functions
	 void CmFileOpen();
	 void EvSize(UINT, TSize&);
	 DECLARE_RESPONSE_TABLE(TMyWindow);
};

DEFINE_RESPONSE_TABLE1(TMyWindow, TWindow)
  EV_WM_SIZE,
  EV_COMMAND(CM_FILEOPEN, CmFileOpen),
END_RESPONSE_TABLE;

TMyWindow::TMyWindow(TWindow *parent)
{
  Init(parent, 0, 0);
  if (!imkBegin())
	 OutputDebugString("Error in imkBegin");
  VbxPicBuf = new TVbxPicBuf(this, 101, "Test", 0, 0, 640, 480);
}

void TMyWindow::CmFileOpen()
{
  TFileOpenDialog::TData FilenameData
	 (OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST,
	 "Bmp (*.Bmp)|*.bmp|Tagra (*.Tga)|*.tga|DIB (*.Dib) |*.dib|PCX (*.PCX)|*.pcx|",
	  0, "", "*");
  if (TFileOpenDialog(this, FilenameData).Execute() == IDOK)
	 VbxPicBuf->SetPropFullPicture(imkLoad(FilenameData.FileName,
		IMK_EXTENSION, 0));
}

void TMyWindow::EvSize(UINT, TSize& size)
{
	VbxPicBuf->MoveWindow(0, 0, size.cx, size.cx, TRUE);
}

class TMyApp : public TApplication {
  public:
	 TMyApp() : TApplication() {}

	 void InitMainWindow()
	 {
		SetMainWindow(new TFrameWindow(0,"Sample ObjectWindows Program", new TMyWindow));
		GetMainWindow()->AssignMenu(MENU_1);
	 }
};

int OwlMain(int /*argc*/, char* /*argv*/ [])
{
  TBIVbxLibrary BIVbxLibrary;
  return TMyApp().Run();
}
